Index: /code/branches/network/TODO
===================================================================
--- /code/branches/network/TODO	(revision 1515)
+++ /code/branches/network/TODO	(revision 1516)
@@ -1,3 +1,2 @@
 - should we use enet_peer_ping to test if a client is still alive ?
 - enet_host_broadcast ? (to all peers)
-- enet_host_check_events ? instead of enet_host_service
Index: /code/branches/network/src/network/ClientInformation.cc
===================================================================
--- /code/branches/network/src/network/ClientInformation.cc	(revision 1515)
+++ /code/branches/network/src/network/ClientInformation.cc	(revision 1516)
@@ -191,4 +191,12 @@
     failures_=0;
   }
+  
+  enet_uint32 ClientInformation::getRTT(){
+    return peer_->roundTripTime;
+  }
+  
+  enet_uint32 ClientInformation::getPacketLoss(){
+    return peer_->packetLoss;
+  }
 
   int ClientInformation::getGamestateID() {
Index: /code/branches/network/src/network/ClientInformation.h
===================================================================
--- /code/branches/network/src/network/ClientInformation.h	(revision 1515)
+++ /code/branches/network/src/network/ClientInformation.h	(revision 1516)
@@ -87,4 +87,6 @@
     void addFailure();
     void resetFailures();
+    enet_uint32 getRTT();
+    enet_uint32 getPacketLoss();
     
     bool removeClient(int clientID);
Index: /code/branches/network/src/network/GameStateClient.cc
===================================================================
--- /code/branches/network/src/network/GameStateClient.cc	(revision 1515)
+++ /code/branches/network/src/network/GameStateClient.cc	(revision 1516)
@@ -82,5 +82,5 @@
       if (loadSnapshot(gs)){
         gameStateMap.insert(std::pair<int, GameState*>(gs->id, gs));
-        COUT(4) << "adding decoded gs with id: " << gs->id << " diffed from: " << gs->base_id << std::endl;
+        COUT(5) << "adding decoded gs with id: " << gs->id << " diffed from: " << gs->base_id << std::endl;
         last_diff_=gs->base_id;
         //last_gamestate_=gs->id;
@@ -241,5 +241,5 @@
       size+=it->getSize(); // size of the actual data of the synchronisable
       size+=3*sizeof(int); // size of datasize, classID and objectID
-      COUT(4) << "getpartialsnapshot: size: " << size << std::endl;
+      COUT(5) << "getpartialsnapshot: size: " << size << std::endl;
     }
     //retval->data = (unsigned char*)malloc(size);
@@ -380,5 +380,5 @@
     //std::cout << "length " << length << std::endl;
     switch ( retval ) {
-      case Z_OK: COUT(4) << "successfully decompressed" << std::endl; break;
+      case Z_OK: COUT(5) << "successfully decompressed" << std::endl; break;
       case Z_MEM_ERROR: COUT(1) << "not enough memory available" << std::endl; return NULL;
       case Z_BUF_ERROR: COUT(2) << "not enough memory available in the buffer" << std::endl; return NULL;
@@ -399,5 +399,5 @@
 
   GameState *GameStateClient::decode(GameState *old, GameStateCompressed *diff) {
-    COUT(4) << "using diffed gamestate" << std::endl;
+    COUT(5) << "using diffed gamestate" << std::endl;
     GameState *t = decode(diff);
     if(!t)
Index: /code/branches/network/src/network/GameStateManager.cc
===================================================================
--- /code/branches/network/src/network/GameStateManager.cc	(revision 1515)
+++ /code/branches/network/src/network/GameStateManager.cc	(revision 1516)
@@ -106,5 +106,5 @@
         break;
       if( (*it).second <= 0 ){
-        COUT(4) << "GameStateManager: deleting gamestate with id: " << (*it).first << ", uses: " << (*it).second << std::endl;
+        COUT(5) << "GameStateManager: deleting gamestate with id: " << (*it).first << ", uses: " << (*it).second << std::endl;
         std::map<int, GameState *>::iterator tempit = gameStateMap.find((*it).first);
         if( tempit != gameStateMap.end() ){
@@ -140,5 +140,6 @@
         client = it->second;
       GameState *server = reference;
-      COUT(4) << "client: " << client << " server: " << server << " gamestatemap: " << &gameStateMap << " size: " << server->size << std::endl;
+      //COUT(4) << "client: " << client << " server: " << server << " gamestatemap: " << &gameStateMap << " size: " << server->size << std::endl;
+      COUT(4) << "client: " << (client!=0 ? client->id : (int)client) << " server: " << server->id << " gamestatemap: " << &gameStateMap << " size: " << server->size << std::endl;
       if(client)
         return encode(client, server);
@@ -267,5 +268,5 @@
       sync.data = data;
       data+=sync.length;
-      COUT(4) << "objectID: " << sync.objectID << " classID: " << sync.classID << std::endl;
+      COUT(5) << "objectID: " << sync.objectID << " classID: " << sync.classID << std::endl;
       while(it && it->objectID!=sync.objectID)
         ++it;
@@ -319,5 +320,5 @@
 
   GameStateCompressed *GameStateManager::encode(GameState *a, GameState *b) {
-    COUT(4) << "G.St.Man: this will be a DIFFED gamestate" << std::endl;
+    COUT(5) << "G.St.Man: this will be a DIFFED gamestate" << std::endl;
     GameState *r = diff(a,b);
     GameStateCompressed *c = compress_(r);
Index: /code/branches/network/src/network/PacketDecoder.cc
===================================================================
--- /code/branches/network/src/network/PacketDecoder.cc	(revision 1515)
+++ /code/branches/network/src/network/PacketDecoder.cc	(revision 1516)
@@ -151,8 +151,8 @@
   void PacketDecoder::gstate( ENetPacket* packet, int clientID )
   {
-    if(!testAndRemoveCRC(packet)){
-      COUT(3) << "crc test of gamestate failed - dropping packet" << std::endl;
-      return;
-    }
+//    if(!testAndRemoveCRC(packet)){
+//     COUT(3) << "crc test of gamestate failed - dropping packet" << std::endl;
+//      return;
+//    }
     GameStateCompressed* currentState = NULL;
     currentState = new GameStateCompressed;
Index: /code/branches/network/src/network/PacketGenerator.cc
===================================================================
--- /code/branches/network/src/network/PacketGenerator.cc	(revision 1515)
+++ /code/branches/network/src/network/PacketGenerator.cc	(revision 1516)
@@ -144,6 +144,6 @@
     COUT(4) << "PacketGenerator generating totalLen " << totalLen << std::endl;
     //delete[] data;
-    if(!addCRC(packet))
-      COUT(3) << "could not add crc to gamestate packet" << std::endl;
+//    if(!addCRC(packet))
+//      COUT(3) << "could not add crc to gamestate packet" << std::endl;
     return packet;
   }
Index: /code/branches/network/src/network/Server.cc
===================================================================
--- /code/branches/network/src/network/Server.cc	(revision 1515)
+++ /code/branches/network/src/network/Server.cc	(revision 1516)
@@ -202,9 +202,9 @@
   void Server::updateGamestate() {
     gamestates->update();
-    COUT(4) << "Server: one gamestate update complete, goig to sendGameState" << std::endl;
+    COUT(5) << "Server: one gamestate update complete, goig to sendGameState" << std::endl;
     //std::cout << "updated gamestate, sending it" << std::endl;
     //if(clients->getGamestateID()!=GAMESTATEID_INITIAL)
     sendGameState();
-    COUT(4) << "Server: one sendGameState turn complete, repeat in next tick" << std::endl;
+    COUT(5) << "Server: one sendGameState turn complete, repeat in next tick" << std::endl;
     //std::cout << "sent gamestate" << std::endl;
   }
@@ -229,4 +229,5 @@
         continue;
       }
+      COUT(4) << "client id: " << temp->getID() << " RTT: " << temp->getRTT() << " loss: " << temp->getPacketLoss() << std::endl;
       COUT(5) << "Server: doing gamestate gamestate preparation" << std::endl;
       int gid = temp->getGamestateID(); //get gamestate id
@@ -312,5 +313,5 @@
     COUT(4) << "Con.Man: creating client id: " << temp->getID() << std::endl;
     connection->syncClassid(temp->getID());
-    COUT(4) << "creating spaceship for clientid: " << temp->getID() << std::endl;
+    COUT(5) << "creating spaceship for clientid: " << temp->getID() << std::endl;
     // TODO: this is only a hack, untill we have a possibility to define default player-join actions
     if(!createShip(temp))
Index: /code/branches/network/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1515)
+++ /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1516)
@@ -469,5 +469,5 @@
         if( myShip_ )
         {
-          COUT(4) << "steering our ship: " << objectID << std::endl;
+          COUT(5) << "steering our ship: " << objectID << std::endl;
           this->acceleration_.x = 0;
           this->acceleration_.y = 0;